<template lang="pug">
  .left-sidebar(
    :style="{ width: (leftSidebarExpanded ? leftSidebarWidth + actionsWidth : actionsWidth) + 'px' }"
    @dragleave="fileDragLeave"
    @dragover.prevent="fileDragOver"
    @drop.prevent="fileDrop($event)"
  )
    .icons(:style="{ width: actionsWidth + 'px' }")
      actions(
        @select-action="toggle"
        @select-search="toggle"
      )
    .content(
      :style="{ left: actionsWidth + 'px', width: leftSidebarWidth + 'px' }"
      :class="{ shown: leftSidebarExpanded, hidden: !leftSidebarExpanded }"
    )
      .upload-overlay(v-show="isFileDragged")
        .upload-overlay-inner
          //- TODO: Fix this icon's fill
          .icon(v-html="$icons['upload']")
      action-content(
        @toggle-background-color-picker="toggleBackgroundColorPicker"
        @selected="toggle"
        ref="content"
      )

    .color-picker-container(
      :class="{ shown: showBackgroundColorPicker, hidden: !showBackgroundColorPicker }"
      ref="backgroundColorPickerContainer"
    )
      color-picker(:initialColor="defaultBackgroundColor" @select="setBackgroundColor" v-on:selectDefault="setBackgroundColor")
    .resizer(v-if="showResizer && leftSidebarExpanded" @mousedown="startDrag($event)" ref="resizer")
</template>

<script>
import { mapState, mapActions } from 'vuex'
import config from '../../config'
import storeService from '../../services/store'
import stageService from '../../services/stage'
import dataService from '~/services/data'
import ChangeBackgroundColorCommand from '../../history/commands/changeBackgroundColor'

export default {
  name: 'LeftSidebar',
  data () {
    return {
      actionsWidth: config.leftSidebar.actionsWidth,
      showBackgroundColorPicker: false,
      showResizer: true,
      background: {},
      startX: undefined,
      startY: undefined,
      startWidth: undefined,
      startHeight: undefined,
      defaultBackgroundColor: config.defaultBackgroundColor,
      isFileDragged: false
    }
  },
  computed: {
    ...mapState({
      currentAction: state => state.editor.currentAction,
      leftSidebarWidth: state => state.editor.leftSidebarWidth,
      leftSidebarExpanded: state => state.editor.leftSidebarExpanded
    })
  },
  mounted () {
    if (window.innerWidth < config.artBoardMinWidth + config.leftSidebar.minWidth + config.leftSidebar.resizerOffset) {
      this.showResizer = false
    }

    this.handleWindowResize()

    window.addEventListener('resize', this.handleWindowResize)
    document.addEventListener('mousedown', this.outsideClick)
  },
  destroyed () {
    window.removeEventListener('resize', this.handleWindowResize)
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    ...mapActions([
      'leftSidebarWidthSet',
      'leftSidebarExpandedSet'
    ]),
    toggle (actionName) {
      if (window.innerWidth < config.artBoardMinWidth + config.leftSidebar.minWidth + config.leftSidebar.actionsWidth) {
        this.leftSidebarExpandedSet((actionName && this.currentAction !== actionName) ? true : !this.leftSidebarExpanded)
      }
    },
    fileDragOver (event) {
      if (event.dataTransfer.types.includes('Files')) {
        this.isFileDragged = true
      }
    },
    fileDragLeave (event) {
      if (event.dataTransfer.types.includes('Files')) {
        this.isFileDragged = false
      }
    },
    fileDrop (event) {
      if (event.dataTransfer.types.includes('Files')) {
        dataService.handleUploads(event.dataTransfer.files)
        this.isFileDragged = false
      }
    },
    toggleBackgroundColorPicker () {
      this.showBackgroundColorPicker = !this.showBackgroundColorPicker
    },
    setBackgroundColor (color) {
      storeService.get('commandManager').execute(new ChangeBackgroundColorCommand(color))
    },
    startDrag (event) {
      this.startX = event.clientX
      this.startY = event.clientY
      this.startWidth = parseInt(document.defaultView.getComputedStyle(this.$el).width, 10)
      this.startHeight = parseInt(document.defaultView.getComputedStyle(this.$el).height, 10)
      document.documentElement.addEventListener('mousemove', this.doDrag, false)
      document.documentElement.addEventListener('mouseup', this.stopDrag, false)
      this.$el.style.overflow = 'hidden'
    },
    doDrag (event) {
      let width = this.startWidth + event.clientX - this.startX
      if (width <= config.leftSidebar.minWidth + config.leftSidebar.actionsWidth) {
        width = config.leftSidebar.minWidth + config.leftSidebar.actionsWidth
      } else if (width >= window.innerWidth - config.artBoardMinWidth - config.leftSidebar.actionsWidth) {
        width = window.innerWidth - config.artBoardMinWidth - config.leftSidebar.actionsWidth
      }
      this.$el.style.width = width + 'px'
      storeService.get('$artBoard').style.width = window.innerWidth - this.$el.offsetWidth + 'px'
      if (storeService.get('$workspace')) {
        stageService.scale()
      }
    },
    stopDrag (event) {
      document.documentElement.removeEventListener('mousemove', this.doDrag, false)
      document.documentElement.removeEventListener('mouseup', this.stopDrag, false)
      this.leftSidebarWidthSet(this.$el.offsetWidth - config.leftSidebar.actionsWidth)
      this.$el.style.overflow = 'initial'
    },
    handleWindowResize () {
      this.leftSidebarExpandedSet(window.innerWidth > config.leftSidebar.actionsWidth + this.leftSidebarWidth + config.artBoardMinWidth)
      const minWidth = config.artBoardMinWidth + this.leftSidebarWidth + config.leftSidebar.actionsWidth + config.leftSidebar.resizerOffset
      this.showResizer = window.innerWidth > minWidth || this.leftSidebarWidth > config.leftSidebar.minWidth
    },
    outsideClick (event) {
      if (
        !this.$refs.backgroundColorPickerContainer.contains(event.target) &&
        (
          this.$refs.content.$refs.backgroundColorPickerButton &&
          this.$refs.content.$refs.backgroundColorPickerButton[0] &&
          !this.$refs.content.$refs.backgroundColorPickerButton[0].contains(event.target)
        )
      ) {
        this.showBackgroundColorPicker = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../../assets/css/mixins';
  @import '../../assets/css/variables';
  @import '../../assets/css/effects';

  .left-sidebar {
    height: 100vh;
    position: absolute;
    top: 0;
    left: 0;
    color: #fff;
    background-color: $sidebar-background-color;

    .icons {
      position: relative;
      z-index: 40;
    }

    .content {
      position: absolute;
      top: 0;
      padding-left: 8px;
      z-index: 10;
      background-color: $sidebar-background-color;

      .upload-overlay {
        z-index: 30;
        height: calc(100% - 56px);
        bottom: 0;
        width: 100%;
        position: absolute;
        pointer-events: none;
        background: $sidebar-background-color;
        padding: 10px 4px;

        .upload-overlay-inner {
          border: 2px dashed rgba(255, 255, 255, 0.2);
          border-radius: 10px;
          width: 100%;
          height: 100%;
          display: flex;
          justify-content: center;
          align-items: center;
          background: rgba(255, 255, 255, 0.02);

          .icon {
            width: 32px;
            height: 42px;
          }
        }
      }

      .search {
        z-index: 20;
      }

      header {
        .title {
          padding: 0 10px 0 4px;
          align-items: center;
          display: flex;
          color: #fff;
          text-transform: uppercase;
          height: 56px;
          font-size: 24px;
          font-weight: bold;

          .badge {
            margin-left: 8px;
            padding: 0 5px;
          }

          .loading {
            width: 22px;
            height: 22px;
            margin-left: 12px;
            position: relative;
            @include loading(#fff, 3px, 22px);
          }
        }
      }

      .title {
        img {
          padding-top: 3px;
          width: 24px;
        }
      }

      .list-container {
        height: calc(100% - 112px);
        z-index: 10;

        .list-shadow {
          width: 100%;
          height: 100%;
          position: absolute;
          z-index: 10;
          background-color: rgba(33, 33, 33, 0.9);
        }
      }

      &.shown {
        opacity: 1;
        z-index: 20;
        @include delay()
      }

      &.hidden {
        left: -500px !important;
        opacity: 0;
        @include delay()
      }
    }

    .color-picker-container {
      position: absolute;
      z-index: 10;
      top: 66px;

      &.shown {
        opacity: 1;
        right: -250px;
        transition: right 0.2s, opacity 0.6s;
      }

      &.hidden {
        opacity: 0;
        right: 454px;
        transition: right 0.8s, opacity 1s;
      }
    }

    .resizer {
      position: absolute;
      width: 6px;
      height: 100%;
      right: -6px;
      top: 0;
      z-index: 30;
      cursor: w-resize;
    }
  }
</style>
